#!/usr/bin/ruby

require './lib/studio_game/game'
require './lib/studio_game/clumsy_player'
require './lib/studio_game/berserk_player'


# player1 = Player.new("moe")
# player2 = Player.new("larry", 60)
# player3 = Player.new("curly", 125)
# player4 = Player.new("Shemp", 90)

game=StudioGame::Game.new("knuckleheads")
klutz = StudioGame::ClumsyPlayer.new("klutz", 105, 3)
game.add_player(klutz)
berserker = StudioGame::BerserkPlayer.new("berserker", 50)
game.add_player(berserker)

# game.add_player(player1)
# game.add_player(player2)
# game.add_player(player3)

# puts File.join(File.dirname(__FILE__),'../data/')
default_players_file = File.join(File.dirname(__FILE__),'../data/', 'players.csv')
game.load(ARGV.shift || default_players_file)
loop do
  puts "How many rounds to play? ('quit' or 'q' to end)"
  rounds = gets.chomp.downcase
  case rounds
  when /^\d+$/
    game.play( rounds.to_i )
  when 'q','quit','e','end','exit'
    game.print_stats
    break
  else
    puts "Enter a number or 'quit'"
  end
end
game.save


clumsy = StudioGame::ClumsyPlayer.new("klutz")
hammer = StudioGame::Treasure.new(:hammer, 50)
clumsy.found_treasure(hammer)
clumsy.found_treasure(hammer)
clumsy.found_treasure(hammer)
crowbar = StudioGame::Treasure.new(:crowbar, 400)
clumsy.found_treasure(crowbar)
clumsy.each_found_treasure do |treasure|
  puts "#{treasure.points} total #{treasure.name} points"
end
puts "#{clumsy.points} grand total points"
