require_relative 'player'

module StudioGame
  class BerserkPlayer < Player
    attr_reader   :woot_count

    def initialize(name, health)
      super(name, health)
      @w00t_count = 0
    end

    def w00t
      super
      @w00t_count += 1
      puts "#{@name} is berserk!" if berserk?
    end

    def blam
      # berserk? ? w00t : super
      w00t      if berserk?
      super unless berserk?
    end

    def berserk?
      return true if @w00t_count > 5
      return false
    end
  end
end

if __FILE__ == $0
  berserker = BerserkPlayer.new("berserker", 50)
  6.times { berserker.w00t }
  2.times { berserker.blam }
  puts berserker.health
end
