require_relative 'playable'
require_relative 'treasure_trove'

module StudioGame
  class Player
    include Playable
    # attr_reader   :health
    attr_accessor :health
    attr_accessor :name, :snacks, :found_treasures

    def initialize(name, health=100)
      @name   = name.capitalize
      @health = health
  		@found_treasures = Hash.new(0)
    end

    def name=(new_name)
      @name = new_name.capitalize
    end

  	def points
  		@found_treasures.values.reduce(0, :+)
  	end

    def found_treasure(treasure)
  		@found_treasures[treasure.name] += treasure.points
      puts "#{@name} found a #{treasure.name} worth #{treasure.points} points."
      puts "#{@name}'s treasures: #{@found_treasures}"
  	end

    def each_found_treasure
      @found_treasures.each do |name, points|
        yield Treasure.new(name, points)
      end
    end

    def score
      puts "Health: #{@health} + Points: #{points}"
      @health + points
    end

    # making a class method allows it to be called when there is no object yet
    def self.from_csv(line)
      name,score = line.split(",")
      score ||= 0
      # player = Player.new(name, score.to_i)
      # below is preferred to create an exception
      player = Player.new( name, Integer(score) )

    end

    def to_csv
      "#{@name},#{@score}"
    end

    def format_score
      formatted_name = @name.ljust(20, '.')
      return "#{formatted_name} #{score}"
    end

    def to_s
      return "I'm #{@name} with health = #{@health}, points = #{points}, and score = #{score}."
    end

  	def <=>(other)
  		other.score <=> score
  	end

  end

  if __FILE__ == $0
    player = Player.new("moe")
    puts player.name
    puts player.health
    player.w00t
    puts player.health
    player.blam
    puts player.health
  end
end
